#!/usr/bin/env python

from MoinMessage import *
from email.mime.text import MIMEText
import sys

if __name__ == "__main__":
    try:
        signer = sys.argv[1]
        recipient = sys.argv[2]
        url = sys.argv[3] + "?action=PostMessage"
        type = sys.argv[4]
        action = sys.argv[5]
        args = sys.argv[6:]
    except IndexError:
        args = None

    if not args:
        print >>sys.stderr, "Need a signer, recipient, URL, update type, action and some updates as arguments to this program."
        sys.exit(1)

    message = Message()
    parts = []

    for arg in args:
        part = MIMEText(arg, "moin", sys.stdin.encoding)
        if type == "collection":
            part["Update-Action"] = action
            message.add_update(part)
        else:
            parts.append(part)

    if type != "collection":
        multipart = message.get_update(parts)
        multipart["Update-Action"] = action
        message.add_update(multipart)

    email_message = message.get_payload()
    gpg = GPG()

    try:
        signed_message = gpg.signMessage(email_message, signer)
        encrypted_message = gpg.encryptMessage(signed_message, recipient)
        print sendMessage(encrypted_message, url)
    except MoinMessageError, exc:
        print exc

# vim: tabstop=4 expandtab shiftwidth=4
